/* ***********************************************************
l_readHTML  Version 0.0.1
サイトマップ作成用　個々のファイルを読み込んで処理する

2014-03-23
hi_tag	http://studyhallweb.info/
*********************************************************** */
part of hi_sitemap;

/**
 * HTMLファイルを読み込んでリンク先のファイル名からURLを取得する
 * hrefが 　../ のとき、一つ上のディレクトリ基準、それ以外はカレント基準
 */
class _ReadHTML {
	String sPath;				// ファイルのフルパス
	List<String> sLink;	// リンク先のフルURL (★まだ使っていない)
	String sCurrentDir;	// カレントディレクトリ(sTopURLに続く部分 最後は'/'なし)

	String sTopURL;
	String sTopDir;			// ローカルファイルのトップディレクトリ
	String sDir;				// ローカルファイルのディレクト
	String sFile;				// 読み込み処理するファイル名

/**
 *  C_stmap 登録済みlocの検索、リンク数のカウントアップのため丸々渡す必要がある
 * 	num nIndex: 処理No. 処理対象HTMLの C_Stmap 内での index
 * 	C_Log エラー書き込み用
 */
	int read(C_Stmap cStmap, C_log cLog) {
		// 読み込み対象ファイルのフルパス
		sPath = sDir + '\\' + sFile;
		// カレントディレクトリ
		if (sTopDir == sDir) {
			sCurrentDir = null;
		} else {
			sCurrentDir = sDir.substring(sTopDir.length + 1, sDir.length);  // 一文字目は'\\'なしにするため + 1
			sCurrentDir = sCurrentDir.replaceAll('\\', '/');	// Directory表記 から URL 表記に変換
		}
		try {
			// HTMLファイルを読み込み1行ずつ処理
			List<String> sReadFile = new List();
		  File oFile = new File(sPath);
			try {
    	  sReadFile = oFile.readAsLinesSync();  // Shift_JIS はここでエラー発生
    	} on Exception catch(e) {
    		String sErr = "FileSystemException: Failed to decode data using encoding 'utf-8'";
    		if (e.toString().indexOf(sErr) == 0) {
    			sReadFile = oFile.readAsLinesSync(encoding: LATIN1);
    													// これならば Shift-JIS もエラーにならない、ただし文字はバケる
    		}
    	}
    	String sLine, sLink;
    	int iS, iE;
			// http:// で始まらない htmlかxmlへの リンクを探す
  		var sReg = new RegExp(r'href="(?!((http)|(https))://).*\.((html)|(html#.+)|(xml)|(xml#.+))"');
  		for (int i = 0; i < sReadFile.length; i++) {
		  	// 1行単位で処理
		  	sLine = sReadFile[i];
		  	sLink = null;	// linkが含まれて居ないときのために初期化
		  	// 1行に複数 <a> があったときのために while処理
    		iS = sLine.indexOf('<a', 0);
    		while (iS != -1) {
    			iE = sLine.indexOf('>', iS);
    			sLink = sLine.substring(iS, iE);	// <a>～</a>
    			sLink = sReg.stringMatch(sLink);  // href="*.html"
    			if (sLink != null) {
    				sLink = sLink.substring('href="'.length, sLink.length - 1);
    											// href=" " を削除
    			}
    			iS = sLine.indexOf('<a ', iE);
    		}
    		// ifream対応
    		if (sLine.indexOf('<iframe') != -1) {
    			iS = sLine.indexOf('src="') + 'src="'.length;
    			iE = sLine.indexOf('"', iS);
    			sLink = sLine.substring(iS, iE);
    		}
				if (sLink != null) {
					// リンクが含まれている行のとき
			  	String sURL = chgURL(sLink);
			  	// 既に　C_Stmap に登録済みか確認
			  	int nIndex = cStmap.sLoc.indexOf(sURL);
					if (nIndex == -1) {
						// 登録されていない (HTMLにリンクが書いてあるがファイルがない)
						String s = 'Link Error: [File]' + sPath + ' [Link]' + sLink;
						cLog.add(s);
					} else {
						// 登録済み リンク数をカウントアップ
						cStmap.nLinks[nIndex] += 1;
					}
				}
		  }
		} on Exception catch(e) {
      print(e);
			return -1;
    } catch(e) {
      return -2;
    }
    return 0;
	}

	/***
	 *  リンク先名からURLを作成、read()の中で使用
	 *
	 *  sLink	: in = href のリンク
	 *  return : http で始まる full URL
	 */
	String chgURL(String sLink) {
		String sURL;
		if (sCurrentDir == null) {
			// 読み込み処理中のファイルがルートディレクトリの場合
			if (sLink == 'index.html') {
				sURL = sTopURL;
			} else {
				// sLink はファイル名のみ または ディレクトリ/ファイル名
				sURL = sTopURL + sLink;
			}
		} else {
			// 読み込み処理中のファイルがルートディレクトリ以外の処理
			sURL = sTopURL + sCurrentDir;	 // 最後に  '/' は付いていない
			if (sLink == 'index.html') {
				sURL += '/';
			} else if (sLink.substring(0, 3) == '../') {
				// 一つ上のディレクトリのとき
				sURL = sURL.substring(0, sURL.lastIndexOf('/'));
				sURL += sLink.substring('..'.length, sLink.length);
								// この時点の sURL は最後に '/' が付いていないため '..' だけを取り除く
			} else {
				// sLink はファイル名のみ または ディレクトリ/ファイル名
				sURL += '/' + sLink;
			}
		}
		// idへのリンク(#付き)への対応
		if (sURL.indexOf('#') != -1) {
			sURL = sURL.substring(0, sURL.lastIndexOf('#'));
		}
		// */index.html への対応 (末尾の index.html を取り除く
		if (sURL.indexOf('index.html') != -1) {
			sURL = sURL.substring(0, sURL.lastIndexOf('/') + 1);	// 最後を'/'にするため +1
		}
		return sURL;
	}
}
